<?php
/**
 * @version		1.5.3.59 tables/category.php
 * @package		J2XML
 * @subpackage	com_j2xml
 * @since		1.5.1
 *
 * @author		Helios Ciancio <info@eshiol.it>
 * @link		http://www.eshiol.it
 * @copyright	Copyright (C) 2010 Helios Ciancio. All Rights Reserved
 * @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL v3
 * J2XML is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access.');

class eshTableCategory extends eshTable
{
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $parent_id			= null;
	/** @var string The menu title for the category (a short name)*/
	var $title				= null;
	/** @var string The full name for the category*/
	var $name				= null;
	/** @var string The the alias for the category*/
	var $alias				= null;
	/** @var string */
	var $image				= null;
	/** @var string */
	var $section				= null;
	/** @var int */
	var $image_position		= null;
	/** @var string */
	var $description			= null;
	/** @var boolean */
	var $published			= null;
	/** @var boolean */
	var $checked_out			= 0;
	/** @var time */
	var $checked_out_time		= 0;
	/** @var int */
	var $ordering			= null;
	/** @var int */
	var $access				= null;
	/** @var string */
	var $params				= null;
	
	/**
	* @param database A database connector object
	*/
	function __construct( &$db )
	{
		parent::__construct( '#__categories', 'id', $db );
	}

	/**
	* Converts record to XML
	* @param boolean Map foreign keys to text values
	*/
	function toXML( $mapKeysToText=false )
	{
		$db =& JFactory::getDBO();
		
		// transform section in sectionid
		if (($mapKeysToText) && (is_numeric($this->section))) 
		{
			$query = 'SELECT alias'
			. ' FROM #__sections'
			. ' WHERE id = '. (int) $this->section
			;
			$db->setQuery($query);
			$this->sectionid = $db->loadResult();
			if ($this->sectionid == null)
			{
				$query = 'SELECT name'
					. ' FROM #__sections'
					. ' WHERE id = '. (int)$this->sectionid
					;
				$db->setQuery($query);
				$this->sectionid = $db->loadResult();
			}
		}
		else
			$this->sectionid = $this->section;

		// backup section value
		$section = $this->section;
		// remove section value
		unset($this->section);
		
		$this->title = htmlspecialchars($this->title);
		$this->description = htmlspecialchars($this->description);
		
		$alias = $this->alias;
		if ($alias = '') $this->alias = $this->name;		
				
		$xml = '<category'.($mapKeysToText ? ' mapkeystotext="true"' : '').'>';
		$xml .= parent::toXML($mapKeysToText);
		$xml .= '</category>';
		
		// restore alias
		$this->alias = $alias;
		
		// restore section value
		$this->section = $section;
		// remove sectionid value
		unset($this->sectionid);
		
		return $xml;
	}
}
