<?php
/**
 * @package JoomlaStats
 * @copyright Copyright (C) 2004-2009 JoomlaStats Team. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @encoding This file must be saved as UTF-8 - No BOM
 */



if( !defined( '_JEXEC' ) ) {
	die( 'JS: No Direct Access' );
}



/* ######################### fill system tables ##################### */



// ##########################
//
//      BROWSERS / BOTS
//
// ##########################
//
// last update: 2008.10.15 mic
//in version 2.2.3 (versions 2.3.0.0 to 2.3.0.84 contain only some of them (not all))
//  - added positions 87, 88
//
// from version 2.5.0.313 this table was concatenated with table #__jstats_bots
//
// NOTICE:
//    a) Positions 0, 1 and 1024 are correct (unknown)! See documentation!
//    a) deprecated entries should be removed (all popular and used at II 2009 contain images!)
//    b) browser_type should be verified and fixed
//    c) in JS there are also images for groups
//         full list is in _JS_DB_TABLE__BROWSERSTYPE define
//    e) browser_fullname should be fixed! - First letter upper case, human freindly
//    f) OmniWeb - is browser for Mac
//    g) Chrome browser - it is a safari browser! so finding Chrome must be before Safari
//          UserAgent string for Google Chrome: "Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US) AppleWebKit/525.19 (KHTML, like Gecko) Chrome/0.2.153.0 Safari/525.19"
//
// RANGES (browser_id):
//            0  - unknown
//    1 -   511  - JS defined internet browsers (1 - unknown browser)
//  512 -  1023  - user defined internet browsers (user can add here own browsers)
// 1024 -  2047  - JS defined bots/spiders/crawlers  (1024 - unknown bot)
// 2048 - 65535  - user defined internet bots/spiders/crawlers (user can add here own bots/spiders/crawlers)

$quer[] = "TRUNCATE TABLE `#__jstats_browsers`";

$quer[] = "INSERT IGNORE INTO `#__jstats_browsers` (`browser_id`, `browsertype_id`, `browser_key`,`browser_name`, `browser_img`) VALUES
(0, 0, '', 'Unknown', 'unknown'),
(1, 0, 'unknown internet browser', 'Unknown Internet Browser', 'unknown'),
(2, 1, 'msie', 'Internet Explorer', 'explorer'),
(3, 2, 'firefox', 'FireFox', 'firefox'),
(4, 5, 'chrome ', 'Google Chrome', 'chrome'),
(5, 3, 'opera', 'Opera', 'opera'),
(6, 5, 'netscape', 'Netscape', 'netscape'),
(7, 5, 'icab', 'iCab', 'noimage'),
(8, 5, 'konqueror', 'Konqueror', 'konqueror'),
(9, 5, 'links', 'Links', 'noimage'),
(10, 5, 'lynx', 'Lynx', 'noimage'),
(11, 5, 'omniweb', 'OmniWeb', 'omniweb'),
(12, 5, 'gecko', 'Mozilla', 'gecko'),
(13, 5, 'wget', 'Wget', 'noimage'),
(14, 5, 'aol-iweng', 'AOL-Iweng', 'noimage'),
(15, 5, 'amaya', 'Amaya', 'noimage'),
(16, 5, 'amigavoyager', 'AmigaVoyager', 'noimage'),
(17, 5, 'aweb', 'AWeb', 'noimage'),
(18, 5, 'bpftp', 'BPFTP', 'noimage'),
(19, 5, 'cyberdog', 'Cyberdog', 'noimage'),
(20, 5, 'dreamcast', 'Dreamcast', 'noimage'),
(21, 5, 'downloadagent', 'DownloadAgent', 'noimage'),
(22, 5, 'ecatch', 'eCatch', 'noimage'),
(23, 5, 'emailsiphon', 'EmailSiphon', 'noimage'),
(24, 5, 'encompass', 'Encompass', 'noimage'),
(25, 5, 'friendlyspider', 'FriendlySpider', 'noimage'),
(26, 5, 'fresco', 'ANT Fresco', 'noimage'),
(27, 5, 'galeon', 'Galeon', 'noimage'),
(28, 5, 'getright', 'GetRight', 'noimage'),
(29, 5, 'headdump', 'HeadDump', 'noimage'),
(30, 5, 'hotjava', 'Sun HotJava', 'noimage'),
(31, 5, 'ibrowse', 'IBrowse', 'noimage'),
(32, 5, 'intergo', 'InterGO', 'noimage'),
(33, 5, 'linemodebrowser', 'W3C Line Mode Browser', 'noimage'),
(34, 5, 'lotus-notes', 'Lotus Notes web client', 'noimage'),
(35, 5, 'macweb', 'MacWeb', 'noimage'),
(36, 5, 'ncsa_mosaic', 'NCSA Mosaic', 'noimage'),
(37, 5, 'netpositive', 'NetPositive', 'noimage'),
(38, 5, 'nutscrape', 'Nutscrape', 'noimage'),
(39, 5, 'msfrontpageexpress', 'MS FrontPage Express', 'noimage'),
(40, 5, 'phoenix', 'Phoenix', 'noimage'),
(41, 5, 'tzgeturl', 'TzGetURL', 'noimage'),
(42, 5, 'viking', 'Viking', 'noimage'),
(43, 5, 'webfetcher', 'WebFetcher', 'noimage'),
(44, 5, 'webexplorer', 'IBM-WebExplorer', 'noimage'),
(45, 5, 'webmirror', 'WebMirror', 'noimage'),
(46, 5, 'webvcr', 'WebVCR', 'noimage'),
(47, 5, 'teleport', 'TelePort Pro', 'noimage'),
(48, 5, 'webcapture', 'Acrobat', 'noimage'),
(49, 5, 'webcopier', 'WebCopier', 'noimage'),
(50, 5, 'real', 'RealAudio or compatible (media player)', 'noimage'),
(51, 5, 'winamp', 'WinAmp (media player)', 'noimage'),
(52, 5, 'windows-media-player', 'Windows Media Player (media player)', 'noimage'),
(53, 5, 'audion', 'Audion (media player)', 'noimage'),
(54, 5, 'freeamp', 'FreeAmp (media player)', 'noimage'),
(55, 5, 'itunes', 'Apple iTunes (media player)', 'noimage'),
(56, 5, 'jetaudio', 'JetAudio (media player)', 'noimage'),
(57, 5, 'mint_audio', 'Mint Audio (media player)', 'noimage'),
(58, 5, 'mpg123', 'mpg123 (media player)', 'noimage'),
(59, 5, 'nsplayer', 'NetShow Player (media player)', 'noimage'),
(60, 5, 'sonique', 'Sonique (media player)', 'noimage'),
(61, 5, 'uplayer', 'Ultra Player (media player)', 'noimage'),
(62, 5, 'xmms', 'XMMS (media player)', 'noimage'),
(63, 5, 'xaudio', 'Some XAudio Engine based MPEG player (media player', 'noimage'),
(64, 4, 'mmef', 'Microsoft Mobile Explorer (PDA/Phone browser)', 'noimage'),
(65, 4, 'mspie', 'MS Pocket Internet Explorer (PDA/Phone browser)', 'noimage'),
(66, 4, 'wapalizer', 'WAPalizer (PDA/Phone browser)', 'noimage'),
(67, 4, 'wapsilon', 'WAPsilon (PDA/Phone browser)', 'noimage'),
(68, 4, 'webcollage', 'WebCollage (PDA/Phone browser)', 'noimage'),
(69, 4, 'alcatel', 'Alcatel Browser (PDA/Phone browser)', 'noimage'),
(70, 4, 'nokia', 'Nokia Browser (PDA/Phone browser)', 'noimage'),
(71, 5, 'webtv', 'WebTV browser', 'noimage'),
(72, 5, 'w3m', 'w3m', 'noimage'),
(73, 5, 'webzip', 'WebZIP', 'noimage'),
(74, 5, 'staroffice', 'StarOffice', 'noimage'),
(75, 5, 'libwww', 'LibWWW', 'noimage'),
(76, 5, 'httrack', 'HTTrack (offline browser utility)', 'noimage'),
(77, 5, 'webstripper', 'webstripper (offline browser)', 'noimage'),
(78, 5, 'safari', 'Safari', 'safari'),
(79, 5, 'avant browser', 'Avant Browser', 'avant'),
(80, 5, 'firebird', 'firebird', 'firebird'),
(81, 5, 'avantgo', 'avantgo', 'noimage'),
(82, 5, 'navio_aoltv', 'navio aoltv', 'noimage'),
(83, 5, 'go!zilla', 'Go!Zilla', 'noimage'),
(84, 5, '22acidownload', '22AciDownload', 'noimage'),


(1024, 0, 'unknown bot', 'Unknown Bot', 'unknown'),
(1025, 0, 'acme.spider', 'Acme Spider', 'noimage'),
(1026, 0, 'ahoythehomepagefinder', 'Ahoy! The Homepage Finder', 'noimage'),
(1027, 0, 'alkaline', 'Alkaline', 'noimage'),
(1028, 0, 'appie', 'Walhello appie', 'noimage'),
(1029, 0, 'arachnophilia', 'Arachnophilia', 'noimage'),
(1030, 0, 'architext', 'ArchitextSpider', 'noimage'),
(1031, 0, 'aretha', 'Aretha', 'noimage'),
(1032, 0, 'ariadne', 'ARIADNE', 'noimage'),
(1033, 0, 'arks', 'arks', 'noimage'),
(1034, 0, 'aspider', 'ASpider (Associative Spider)', 'noimage'),
(1035, 0, 'atn.txt', 'ATN Worldwide', 'noimage'),
(1036, 0, 'atomz', 'Atomz.com Search Robot', 'noimage'),
(1037, 0, 'auresys', 'AURESYS', 'noimage'),
(1038, 0, 'backrub', 'BackRub', 'noimage'),
(1039, 0, 'biUKrother', 'Big Brother', 'noimage'),
(1040, 0, 'bjaaland', 'Bjaaland', 'noimage'),
(1041, 0, 'blackwidow', 'BlackWidow', 'noimage'),
(1042, 0, 'blindekuh', 'Die Blinde Kuh', 'noimage'),
(1043, 0, 'bloodhound', 'Bloodhound', 'noimage'),
(1044, 0, 'brightnet', 'bright.net caching robot', 'noimage'),
(1045, 0, 'bspider', 'BSpider', 'noimage'),
(1046, 0, 'cactvschemistryspider', 'CACTVS Chemistry Spider', 'noimage'),
(1047, 0, 'calif[^r]', 'Calif', 'noimage'),
(1048, 0, 'cassandra', 'Cassandra', 'noimage'),
(1049, 0, 'cgireader', 'Digimarc Marcspider/CGI', 'noimage'),
(1050, 0, 'checkbot', 'Checkbot', 'noimage'),
(1051, 0, 'churl', 'churl', 'noimage'),
(1052, 0, 'cmc', 'CMC/0.01', 'noimage'),
(1053, 0, 'collective', 'Collective', 'noimage'),
(1054, 0, 'combine', 'Combine System', 'noimage'),
(1055, 0, 'conceptbot', 'Conceptbot', 'noimage'),
(1056, 0, 'coolbot', 'CoolBot', 'noimage'),
(1057, 0, 'core', 'Web Core / Roots', 'noimage'),
(1058, 0, 'cosmos', 'XYLEME Robot', 'noimage'),
(1059, 0, 'cruiser', 'Internet Cruiser Robot', 'noimage'),
(1060, 0, 'cusco', 'Cusco', 'noimage'),
(1061, 0, 'cyberspyder', 'CyberSpyder Link Test', 'noimage'),
(1062, 0, 'deweb', 'DeWeb(c) Katalog/Index', 'noimage'),
(1063, 0, 'dienstspider', 'DienstSpider', 'noimage'),
(1064, 0, 'digger', 'Digger', 'noimage'),
(1065, 0, 'diibot', 'Digital Integrity Robot', 'noimage'),
(1066, 0, 'directhit', 'Direct Hit Grabber', 'noimage'),
(1067, 0, 'dnabot', 'DNAbot', 'noimage'),
(1068, 0, 'download_express', 'DownLoad Express', 'noimage'),
(1069, 0, 'dragonbot', 'DragonBot', 'noimage'),
(1070, 0, 'dwcp', 'DWCP (Dridus Web Cataloging Project)', 'noimage'),
(1071, 0, 'e-collector', 'e-collector', 'noimage'),
(1072, 0, 'ebiness', 'EbiNess', 'noimage'),
(1073, 0, 'eit', 'EIT Link Verifier Robot', 'noimage'),
(1074, 0, 'elfinbot', 'ELFINBOT', 'noimage'),
(1075, 0, 'emacs', 'Emacs-w3 Search Engine', 'noimage'),
(1076, 0, 'emcspider', 'ananzi', 'noimage'),
(1077, 0, 'esther', 'Esther', 'noimage'),
(1078, 0, 'evliyacelebi', 'Evliya Celebi', 'noimage'),
(1079, 0, 'nzexplorer', 'nzexplorer', 'noimage'),
(1080, 0, 'fdse', 'Fluid Dynamics Search Engine robot', 'noimage'),
(1081, 0, 'felix', 'Felix IDE', 'noimage'),
(1082, 0, 'ferret', 'Wild Ferret Web Hopper #1, #2, #3', 'noimage'),
(1083, 0, 'fetchrover', 'FetchRover', 'noimage'),
(1084, 0, 'fido', 'fido', 'noimage'),
(1085, 0, 'finnish', 'Hmhkki', 'noimage'),
(1086, 0, 'fireball', 'KIT-Fireball', 'noimage'),
(1087, 0, '[^a]fish', 'Fish search', 'noimage'),
(1088, 0, 'fouineur', 'Fouineur', 'noimage'),
(1089, 0, 'francoroute', 'Robot Francoroute', 'noimage'),
(1090, 0, 'freecrawl', 'Freecrawl', 'noimage'),
(1091, 0, 'funnelweb', 'FunnelWeb', 'noimage'),
(1092, 0, 'gama', 'gammaSpider, FocusedCrawler', 'noimage'),
(1093, 0, 'gazz', 'gazz', 'noimage'),
(1094, 0, 'gcreep', 'GCreep', 'noimage'),
(1095, 0, 'getbot', 'GetBot', 'noimage'),
(1096, 0, 'geturl', 'GetURL', 'noimage'),
(1097, 0, 'golem', 'Golem', 'noimage'),
(1098, 0, 'googlebot', 'Googlebot (Google)', 'noimage'),
(1099, 0, 'grapnel', 'Grapnel/0.01 Experiment', 'noimage'),
(1100, 0, 'griffon', 'Griffon', 'noimage'),
(1101, 0, 'gromit', 'Gromit', 'noimage'),
(1102, 0, 'gulliver', 'Northern Light Gulliver', 'noimage'),
(1103, 0, 'hambot', 'HamBot', 'noimage'),
(1104, 0, 'harvest', 'Harvest', 'noimage'),
(1105, 0, 'havindex', 'havIndex', 'noimage'),
(1106, 0, 'hometown', 'Hometown Spider Pro', 'noimage'),
(1107, 0, 'htdig', 'ht://Dig', 'noimage'),
(1108, 0, 'htmlgobble', 'HTMLgobble', 'noimage'),
(1109, 0, 'hyperdecontextualizer', 'Hyper-Decontextualizer', 'noimage'),
(1110, 0, 'iajabot', 'iajaBot', 'noimage'),
(1111, 0, 'ibm', 'IBM_Planetwide', 'noimage'),
(1112, 0, 'iconoclast', 'Popular Iconoclast', 'noimage'),
(1113, 0, 'ilse', 'Ingrid', 'noimage'),
(1114, 0, 'imagelock', 'Imagelock', 'noimage'),
(1115, 0, 'incywincy', 'IncyWincy', 'noimage'),
(1116, 0, 'informant', 'Informant', 'noimage'),
(1117, 0, 'infoseek', 'InfoSeek Robot 1.0', 'noimage'),
(1118, 0, 'infoseeksidewinder', 'Infoseek Sidewinder', 'noimage'),
(1119, 0, 'infospider', 'InfoSpiders', 'noimage'),
(1120, 0, 'inspectorwww', 'Inspector Web', 'noimage'),
(1121, 0, 'intelliagent', 'IntelliAgent', 'noimage'),
(1122, 0, 'irobot', 'I, Robot', 'noimage'),
(1123, 0, 'iron33', 'Iron33', 'noimage'),
(1124, 0, 'israelisearch', 'Israeli-search', 'noimage'),
(1125, 0, 'javabee', 'JavaBee', 'noimage'),
(1126, 0, 'jbot', 'JBot Java Web Robot', 'noimage'),
(1127, 0, 'jcrawler', 'JCrawler', 'noimage'),
(1128, 0, 'jeeves', 'Jeeves', 'noimage'),
(1129, 0, 'jobo', 'JoBo Java Web Robot', 'noimage'),
(1130, 0, 'jobot', 'Jobot', 'noimage'),
(1131, 0, 'joebot', 'JoeBot', 'noimage'),
(1132, 0, 'jubii', 'The Jubii Indexing Robot', 'noimage'),
(1133, 0, 'jumpstation', 'JumpStation', 'noimage'),
(1134, 0, 'katipo', 'Katipo', 'noimage'),
(1135, 0, 'kdd', 'KDD-Explorer', 'noimage'),
(1136, 0, 'kilroy', 'Kilroy', 'noimage'),
(1137, 0, 'ko_yappo_robot', 'KO_Yappo_Robot', 'noimage'),
(1138, 0, 'labelgrabber.txt', 'LabelGrabber', 'noimage'),
(1139, 0, 'larbin', 'larbin', 'noimage'),
(1140, 0, 'legs', 'legs', 'noimage'),
(1141, 0, 'linkidator', 'Link Validator', 'noimage'),
(1142, 0, 'linkscan', 'LinkScan', 'noimage'),
(1143, 0, 'linkwalker', 'LinkWalker', 'noimage'),
(1144, 0, 'lockon', 'Lockon', 'noimage'),
(1145, 0, 'logo_gif', 'logo.gif Crawler', 'noimage'),
(1146, 0, 'lycos', 'Lycos', 'noimage'),
(1147, 0, 'macworm', 'Mac WWWWorm', 'noimage'),
(1148, 0, 'magpie', 'Magpie', 'noimage'),
(1149, 0, 'marvin', 'marvin/infoseek', 'noimage'),
(1150, 0, 'mattie', 'Mattie', 'noimage'),
(1151, 0, 'mediafox', 'MediaFox', 'noimage'),
(1152, 0, 'merzscope', 'MerzScope', 'noimage'),
(1153, 0, 'meshexplorer', 'NEC-MeshExplorer', 'noimage'),
(1154, 0, 'mindcrawler', 'MindCrawler', 'noimage'),
(1155, 0, 'moget', 'moget', 'noimage'),
(1156, 0, 'momspider', 'MOMspider', 'noimage'),
(1157, 0, 'monster', 'Monster', 'noimage'),
(1158, 0, 'motor', 'Motor', 'noimage'),
(1159, 0, 'muscatferret', 'Muscat Ferret', 'noimage'),
(1160, 0, 'mwdsearch', 'Mwd.Search', 'noimage'),
(1161, 0, 'myweb', 'Internet Shinchakubin', 'noimage'),
(1162, 0, 'netcarta', 'NetCarta WebMap Engine', 'noimage'),
(1163, 0, 'netcraft', 'Netcraft Web Server Survey', 'noimage'),
(1164, 0, 'netmechanic', 'NetMechanic', 'noimage'),
(1165, 0, 'netscoop', 'NetScoop', 'noimage'),
(1166, 0, 'newscan-online', 'newscan-online', 'noimage'),
(1167, 0, 'nhse', 'NHSE Web Forager', 'noimage'),
(1168, 0, 'nomad', 'Nomad', 'noimage'),
(1169, 0, 'northstar', 'The NorthStar Robot', 'noimage'),
(1170, 0, 'occam', 'Occam', 'noimage'),
(1171, 0, 'octopus', 'HKU WWW Octopus', 'noimage'),
(1172, 0, 'openfind', 'Openfind data gatherer', 'noimage'),
(1173, 0, 'orb_search', 'Orb Search', 'noimage'),
(1174, 0, 'packrat', 'Pack Rat', 'noimage'),
(1175, 0, 'pageboy', 'PageBoy', 'noimage'),
(1176, 0, 'parasite', 'ParaSite', 'noimage'),
(1177, 0, 'patric', 'Patric', 'noimage'),
(1178, 0, 'pegasus', 'pegasus', 'noimage'),
(1179, 0, 'perignator', 'The Peregrinator', 'noimage'),
(1180, 0, 'perlcrawler', 'PerlCrawler 1.0', 'noimage'),
(1181, 0, 'phantom', 'Phantom', 'noimage'),
(1182, 0, 'piltdownman', 'PiltdownMan', 'noimage'),
(1183, 0, 'pimptrain', 'Pimptrain.com''s robot', 'noimage'),
(1184, 0, 'pioneer', 'Pioneer', 'noimage'),
(1185, 0, 'pitkow', 'html_analyzer', 'noimage'),
(1186, 0, 'pjspider', 'Portal Juice Spider', 'noimage'),
(1187, 0, 'pka', 'PGP Key Agent', 'noimage'),
(1188, 0, 'plumtreewebaccessor', 'PlumtreeWebAccessor', 'noimage'),
(1189, 0, 'poppi', 'Poppi', 'noimage'),
(1190, 0, 'portalb', 'PortalB Spider', 'noimage'),
(1191, 0, 'puu', 'GetterroboPlus Puu', 'noimage'),
(1192, 0, 'python', 'The Python Robot', 'noimage'),
(1193, 0, 'raven', 'Raven Search', 'noimage'),
(1194, 0, 'rbse', 'RBSE Spider', 'noimage'),
(1195, 0, 'resumerobot', 'Resume Robot', 'noimage'),
(1196, 0, 'rhcs', 'RoadHouse Crawling System', 'noimage'),
(1197, 0, 'roadrunner', 'Road Runner: The ImageScape Robot', 'noimage'),
(1198, 0, 'robbie', 'Robbie the Robot', 'noimage'),
(1199, 0, 'robi', 'ComputingSite Robi/1.0', 'noimage'),
(1200, 0, 'robofox', 'RoboFox', 'noimage'),
(1201, 0, 'robozilla', 'Robozilla', 'noimage'),
(1202, 0, 'roverbot', 'Roverbot', 'noimage'),
(1203, 0, 'rules', 'RuLeS', 'noimage'),
(1204, 0, 'safetynetrobot', 'SafetyNet Robot', 'noimage'),
(1205, 0, 'scooter', 'Scooter (AltaVista)', 'noimage'),
(1206, 0, 'search_au', 'Search.Aus-AU.COM', 'noimage'),
(1207, 0, 'searchprocess', 'SearchProcess', 'noimage'),
(1208, 0, 'senrigan', 'Senrigan', 'noimage'),
(1209, 0, 'sgscout', 'SG-Scout', 'noimage'),
(1210, 0, 'shaggy', 'ShagSeeker', 'noimage'),
(1211, 0, 'shaihulud', 'Shai''Hulud', 'noimage'),
(1212, 0, 'sift', 'Sift', 'noimage'),
(1213, 0, 'simbot', 'Simmany Robot Ver1.0', 'noimage'),
(1214, 0, 'site-valet', 'Site Valet', 'noimage'),
(1215, 0, 'sitegrabber', 'Open Text Index Robot', 'noimage'),
(1216, 0, 'sitetech', 'SiteTech-Rover', 'noimage'),
(1217, 0, 'slcrawler', 'SLCrawler', 'noimage'),
(1218, 0, 'slurp', 'Inktomi Slurp', 'noimage'),
(1219, 0, 'smartspider', 'Smart Spider', 'noimage'),
(1220, 0, 'snooper', 'Snooper', 'noimage'),
(1221, 0, 'solbot', 'Solbot', 'noimage'),
(1222, 0, 'spanner', 'Spanner', 'noimage'),
(1223, 0, 'speedy', 'Speedy Spider', 'noimage'),
(1224, 0, 'spider_monkey', 'spider_monkey', 'noimage'),
(1225, 0, 'spiderbot', 'SpiderBot', 'noimage'),
(1226, 0, 'spiderline', 'Spiderline Crawler', 'noimage'),
(1227, 0, 'spiderman', 'SpiderMan', 'noimage'),
(1228, 0, 'spiderview', 'SpiderView(tm)', 'noimage'),
(1229, 0, 'spry', 'Spry Wizard Robot', 'noimage'),
(1230, 0, 'ssearcher', 'Site Searcher', 'noimage'),
(1231, 0, 'suke', 'Suke', 'noimage'),
(1232, 0, 'suntek', 'suntek search engine', 'noimage'),
(1233, 0, 'sven', 'Sven', 'noimage'),
(1234, 0, 'tach_bw', 'TACH Black Widow', 'noimage'),
(1235, 0, 'tarantula', 'Tarantula', 'noimage'),
(1236, 0, 'tarspider', 'tarspider', 'noimage'),
(1237, 0, 'techbot', 'TechBOT', 'noimage'),
(1238, 0, 'templeton', 'Templeton', 'noimage'),
(1239, 0, 'teoma_agent1', 'TeomaTechnologies', 'noimage'),
(1240, 0, 'titin', 'TitIn', 'noimage'),
(1241, 0, 'titan', 'TITAN', 'noimage'),
(1242, 0, 'tkwww', 'The TkWWW Robot', 'noimage'),
(1243, 0, 'tlspider', 'TLSpider', 'noimage'),
(1244, 0, 'ucsd', 'UCSD Crawl', 'noimage'),
(1245, 0, 'udmsearch', 'UdmSearch', 'noimage'),
(1246, 0, 'urlck', 'URL Check', 'noimage'),
(1247, 0, 'valkyrie', 'Valkyrie', 'noimage'),
(1248, 0, 'victoria', 'Victoria', 'noimage'),
(1249, 0, 'visionsearch', 'vision-search', 'noimage'),
(1250, 0, 'voyager', 'Voyager', 'noimage'),
(1251, 0, 'vwbot', 'VWbot', 'noimage'),
(1252, 0, 'w3index', 'The NWI Robot', 'noimage'),
(1253, 0, 'w3m2', 'W3M2', 'noimage'),
(1254, 0, 'wallpaper', 'WallPaper', 'noimage'),
(1255, 0, 'wanderer', 'the World Wide Web Wanderer', 'noimage'),
(1256, 0, 'wapspider', 'w@pSpider by wap4.com', 'noimage'),
(1257, 0, 'webbandit', 'WebBandit Web Spider', 'noimage'),
(1258, 0, 'webcatcher', 'WebCatcher', 'noimage'),
(1259, 0, 'webcopy', 'WebCopy', 'noimage'),
(1260, 0, 'webfetcher', 'Webfetcher', 'noimage'),
(1261, 0, 'webfoot', 'The Webfoot Robot', 'noimage'),
(1262, 0, 'weblayers', 'Weblayers', 'noimage'),
(1263, 0, 'weblinker', 'WebLinker', 'noimage'),
(1264, 0, 'webmirror', 'WebMirror', 'noimage'),
(1265, 0, 'webmoose', 'The Web Moose', 'noimage'),
(1266, 0, 'webquest', 'WebQuest', 'noimage'),
(1267, 0, 'webreader', 'Digimarc MarcSpider', 'noimage'),
(1268, 0, 'webreaper', 'WebReaper', 'noimage'),
(1269, 0, 'websnarf', 'Websnarf', 'noimage'),
(1270, 0, 'webspider', 'WebSpider', 'noimage'),
(1271, 0, 'webvac', 'WebVac', 'noimage'),
(1272, 0, 'webwalk', 'webwalk', 'noimage'),
(1273, 0, 'webwalker', 'WebWalker', 'noimage'),
(1274, 0, 'webwatch', 'WebWatch', 'noimage'),
(1275, 0, 'wget', 'Wget', 'noimage'),
(1276, 0, 'whatuseek', 'whatUseek Winona', 'noimage'),
(1277, 0, 'whowhere', 'WhoWhere Robot', 'noimage'),
(1278, 0, 'wired-digital', 'Wired Digital', 'noimage'),
(1279, 0, 'wmir', 'w3mir', 'noimage'),
(1280, 0, 'wolp', 'WebStolperer', 'noimage'),
(1281, 0, 'wombat', 'The Web Wombat', 'noimage'),
(1282, 0, 'worm', 'The World Wide Web Worm', 'noimage'),
(1283, 0, 'wwwc', 'WWWC Ver 0.2.5', 'noimage'),
(1284, 0, 'wz101', 'WebZinger', 'noimage'),
(1285, 0, 'xget', 'XGET', 'noimage'),
(1286, 0, 'nederland.zoek', 'Nederland.zoek', 'noimage'),
(1287, 0, 'antibot', 'Antibot', 'noimage'),
(1288, 0, 'awbot', 'AWBot', 'noimage'),
(1289, 0, 'baiduspider', 'BaiDuSpider', 'noimage'),
(1290, 0, 'bobby', 'Bobby', 'noimage'),
(1291, 0, 'boris', 'Boris', 'noimage'),
(1292, 0, 'bumblebee', 'Bumblebee (relevare.com)', 'noimage'),
(1293, 0, 'cscrawler', 'CsCrawler', 'noimage'),
(1294, 0, 'daviesbot', 'DaviesBot', 'noimage'),
(1295, 0, 'digout4u', 'Digout4u', 'noimage'),
(1296, 0, 'echo', 'EchO!', 'noimage'),
(1297, 0, 'exactseek', 'ExactSeek Crawler', 'noimage'),
(1298, 0, 'ezresult', 'Ezresult', 'noimage'),
(1299, 0, 'fast-webcrawler', 'Fast-Webcrawler (AllTheWeb)', 'noimage'),
(1300, 0, 'gigabot', 'GigaBot', 'noimage'),
(1301, 0, 'gnodspider', 'GNOD Spider', 'noimage'),
(1302, 0, 'ia_archiver', 'Alexa (IA Archiver)', 'noimage'),
(1303, 0, 'internetseer', 'InternetSeer', 'noimage'),
(1304, 0, 'jennybot', 'JennyBot', 'noimage'),
(1305, 0, 'justview', 'JustView', 'noimage'),
(1306, 0, 'linkbot', 'LinkBot', 'noimage'),
(1307, 0, 'linkchecker', 'LinkChecker', 'noimage'),
(1308, 0, 'mercator', 'Mercator', 'noimage'),
(1309, 0, 'msiecrawler', 'MSIECrawler', 'noimage'),
(1310, 0, 'perman', 'Perman surfer', 'noimage'),
(1311, 0, 'petersnews', 'Petersnews', 'noimage'),
(1312, 0, 'pompos', 'Pompos', 'noimage'),
(1313, 0, 'psbot', 'psBot', 'noimage'),
(1314, 0, 'redalert', 'Red Alert', 'noimage'),
(1315, 0, 'shoutcast', 'Shoutcast Directory Service', 'noimage'),
(1316, 0, 'slysearch', 'SlySearch', 'noimage'),
(1317, 0, 'turnitinbot', 'Turn It In', 'noimage'),
(1318, 0, 'ultraseek', 'Ultraseek', 'noimage'),
(1319, 0, 'unlost_web_crawler', 'Unlost Web Crawler', 'noimage'),
(1320, 0, 'voila', 'Voila', 'noimage'),
(1321, 0, 'webbase', 'WebBase', 'noimage'),
(1322, 0, 'webcompass', 'webcompass', 'noimage'),
(1323, 0, 'wisenutbot', 'WISENutbot (Looksmart)', 'noimage'),
(1324, 0, 'yandex', 'Yandex bot', 'noimage'),
(1325, 0, 'zyborg', 'Zyborg (Looksmart)', 'noimage'),
(1332, 0, 'mixcat', 'morris - mixcat crawler', 'noimage'),
(1329, 0, 'netresearchserver', 'Net Research Server', 'noimage'),
(1330, 0, 'vagabondo', 'vagabondo (test version WiseGuys webagent)', 'noimage'),
(1331, 0, 'szukacz', 'Szukacz crawler', 'noimage'),
(1333, 0, 'grub-client', 'Grub''s distributed crawler', 'noimage'),
(1334, 0, 'fluffy', 'fluffy (searchhippo)', 'noimage'),
(1335, 0, 'webtrends link analyzer', 'webtrends link analyzer', 'noimage'),
(1336, 0, 'naverrobot', 'naver', 'noimage'),
(1337, 0, 'steeler', 'steeler', 'noimage'),
(1338, 0, 'bordermanager', 'bordermanager', 'noimage'),
(1339, 0, 'nutch', 'Nutch', 'noimage'),
(1340, 0, 'teradex', 'Teradex', 'noimage'),
(1341, 0, 'deepindex', 'DeepIndex', 'noimage'),
(1342, 0, 'npbot', 'NPBot', 'noimage'),
(1343, 0, 'webcraftboot', 'Webcraftboot', 'noimage'),
(1344, 0, 'franklin locator', 'Franklin locator', 'noimage'),
(1345, 0, 'internet ninja', 'Internet ninja', 'noimage'),
(1346, 0, 'space bison', 'Space bison', 'noimage'),
(1347, 0, 'gornker', 'gornker crawler', 'noimage'),
(1348, 0, 'gaisbot', 'Gaisbot', 'noimage'),
(1349, 0, 'cj spider', 'CJ spider', 'noimage'),
(1350, 0, 'semanticdiscovery', 'Semantic Discovery', 'noimage'),
(1351, 0, 'zao', 'Zao', 'noimage'),
(1352, 0, 'web downloader', 'Web Downloader', 'noimage'),
(1353, 0, 'webstripper', 'Webstripper', 'noimage'),
(1354, 0, 'zeus', 'Zeus', 'noimage'),
(1355, 0, 'webrace', 'Webrace', 'noimage'),
(1356, 0, 'christcrawler', 'ChristCENTRAL', 'noimage'),
(1357, 0, 'webfilter', 'Webfilter', 'noimage'),
(1358, 0, 'webgather', 'Webgather', 'noimage'),
(1359, 0, 'surveybot', 'Surveybot', 'noimage'),
(1360, 0, 'nitle blog spider', 'Nitle Blog Spider', 'noimage'),
(1361, 0, 'galaxybot', 'Galaxybot', 'noimage'),
(1362, 0, 'fangcrawl', 'FangCrawl', 'noimage'),
(1363, 0, 'searchspider', 'SearchSpider', 'noimage'),
(1364, 0, 'msnbot', 'msnbot', 'noimage'),
(1365, 0, 'computer_and_automation_research_institute_crawler', 'computer and automation research institute crawler', 'noimage'),
(1366, 0, 'overture-webcrawler', 'overture-webcrawler', 'noimage'),
(1367, 0, 'exalead ng', 'exalead ng', 'noimage'),
(1368, 0, 'denmex websearch', 'denmex websearch', 'noimage'),
(1369, 0, 'linkfilter.net url verifier', 'linkfilter.net url verifier', 'noimage'),
(1370, 0, 'mac finder', 'mac finder', 'noimage'),
(1371, 0, 'polybot', 'polybot', 'noimage'),
(1372, 0, 'quepasacreep', 'quepasacreep', 'noimage'),
(1373, 0, 'xenu link sleuth', 'xenu link sleuth', 'noimage'),
(1374, 0, 'hatena antenna', 'hatena antenna', 'noimage'),
(1375, 0, 'timbobot', 'timbobot', 'noimage'),
(1376, 0, 'waypath scout', 'waypath scout', 'noimage'),
(1377, 0, 'technoratibot', 'technoratibot', 'noimage'),
(1378, 0, 'frontier', 'frontier', 'noimage'),
(1379, 0, 'blogosphere', 'blogosphere', 'noimage'),
(1380, 0, 'my little bot', 'my little bot', 'noimage'),
(1381, 0, 'illinois state tech labs', 'illinois state tech labs', 'noimage'),
(1382, 0, 'splatsearch.com', 'splatsearch', 'noimage'),
(1383, 0, 'blogshares bot', 'blogshares bot', 'noimage'),
(1384, 0, 'fastbuzz.com', 'fastbuzz', 'noimage'),
(1385, 0, 'obidos-bot', 'obidos', 'noimage'),
(1386, 0, 'blogwise.com-metachecker', 'blogwise.com metachecker', 'noimage'),
(1387, 0, 'bravobrian bstop', 'bravobrian bstop', 'noimage'),
(1388, 0, 'feedster crawler', 'feedster', 'noimage'),
(1389, 0, 'isspider', 'blogpulse', 'noimage'),
(1390, 0, 'syndic8', 'syndic8', 'noimage'),
(1391, 0, 'blogvisioneye', 'blogvisioneye', 'noimage'),
(1392, 0, 'downes/referrers', 'downes/referrers', 'noimage'),
(1393, 0, 'naverbot', 'naverbot', 'noimage'),
(1394, 0, 'soziopath', 'soziopath', 'noimage'),
(1395, 0, 'nextopiabot', 'nextopiabot', 'noimage'),
(1396, 0, 'ingrid', 'ingrid', 'noimage'),
(1397, 0, 'vspider', 'vspider', 'noimage'),
(1398, 0, 'yahoo', 'Yahoo', 'noimage'),
(1399, 0, 'sherlock-spider', 'Sherlock Spider', 'noimage'),
(1400, 0, 'mercubot', 'Mercubot', 'noimage'),
(1401, 0, 'mediapartners-google', 'Mediapartners Google', 'noimage'),
(1402, 0, 'jetbot', 'JetBot', 'noimage'),
(1403, 0, 'faxobot', 'FaxoBot', 'noimage'),
(1404, 0, 'cosmixcrawler', 'cosmix crawler', 'noimage'),
(1405, 0, 'exabot', 'exabot', 'noimage'),
(1406, 0, 'sitespider', 'sitespider', 'noimage'),
(1407, 0, 'pipeliner', 'pipeliner', 'noimage'),
(1408, 0, 'ccgcrawl', 'ccgcrawl', 'noimage'),
(1409, 0, 'cydralspider', 'cydralspider', 'noimage'),
(1410, 0, 'crawlconvera', 'crawlconvera', 'noimage'),
(1411, 0, 'blogwatcher', 'blogwatcher', 'noimage'),
(1412, 0, 'mozdex', 'mozdex', 'noimage'),
(1413, 0, 'aleksika spider', 'aleksika spider', 'noimage'),
(1414, 0, 'e-societyrobot', 'e-societyrobot', 'noimage'),
(1415, 0, 'enterprise_search', 'enterprise search', 'noimage'),
(1416, 0, 'seekbot', 'seekbot', 'noimage'),
(1417, 0, 'emeraldshield', 'emeraldshield', 'noimage'),
(1418, 0, 'mj12bot', 'mj12bot', 'noimage'),
(1419, 0, 'aipbot', 'aipbot', 'noimage'),
(1420, 0, 'omniexplorer_bot', 'omniexplorer_bot', 'noimage'),
(1421, 0, 'shim-crawler', 'shim-crawler', 'noimage'),
(1422, 0, 'nimblecrawler', 'nimblecrawler', 'noimage'),
(1423, 0, 'msrbot', 'msrbot', 'noimage'),
(1424, 0, 'scirus', 'scirus', 'noimage'),
(1425, 0, 'geniebot', 'geniebot', 'noimage'),
(1426, 0, 'nextgensearchbot', 'nextgensearchbot', 'noimage'),
(1427, 0, 'ichiro', 'ichiro', 'noimage'),
(1428, 0, 'peerfactor 404 crawler', 'peerfactor 404 crawler', 'noimage'),
(1429, 0, 'ebay relevance ad crawler', 'Ebay relevance ad crawler', 'noimage'),
(1430, 0, 'yodaobot', 'yodaobot/1.0', 'noimage'),
(1431, 0, 'vmbot', 'vmbot/0.9', 'noimage'),
(1432, 0, 'blaiz-bee', 'Blaiz-Bee/2.00.*', 'noimage'),
(1433, 0, 'sensis', 'Sensis Web Crawler', 'noimage'),
(1434, 0, 'abachobot', 'ABACHOBot', 'noimage'),
(1435, 0, 'abilogicbot', 'AbiLogicBot http://www.abilogic.com/bot.html', 'noimage'),
(1436, 0, 'googlebot-image', 'Googlebot-Image', 'noimage'),
(1437, 0, 'emailsiphon', 'EmailSiphon (Sonic) - Email Collector', 'noimage'),
(1438, 0, 'w3c-checklink', 'W3C Linkchecker', 'noimage'),
(1439, 0, 'w3c_validator', 'W3C XHTML/HTML Validator', 'noimage'),
(1440, 0, 'w3c_css_validator', 'W3C CSS Validator', 'noimage'),
(1441, 0, 'wdg_validator', 'WDG HTML Validator', 'noimage'),
(1442, 0, 'csscheck', 'WDG CSS Validator', 'noimage'),
(1443, 0, 'depspid', 'DepSpid http://about.depspid.net', 'noimage'),
(1445, 0, 'panscient.com', 'Panscient web crawler http://panscient.com', 'noimage'),
(1446, 0, 'bloglines', 'Web based Feed reader for Ask Jeeves Bloglines (ht', 'noimage'),
(1447, 0, 'everyfeed-spider', 'http://www.everyfeed.com', 'noimage'),
(1448, 0, 'feedfetcher-google', 'Google''s feedfetcher (http://www.google.com/feedfe', 'noimage'),
(1449, 0, 'gregarius', 'http://devlog.gregarius.net/docs/ua', 'noimage'),
(1450, 0, 'cse html validator lite online', 'Free online HTML Editor and Syntax Checker (http:/', 'noimage'),
(1451, 0, 'cynthia', 'Validator for HiSoftware Cynthia Says portal (http', 'noimage'),
(1452, 0, 'htmlparser', 'HTML Parser a Java library used to parse HTML (htt', 'noimage'),
(1453, 0, 'p3p validator', 'Platform for Privacy Preferences Project (P3P) by ', 'noimage')
";




// search engines
//in version 2.2.3 (versions 2.3.0.0 to 2.3.0.84 contain only some of them (not all))
//  - added positions 82-88
//  - modified positions: 9, 12
// since 3.0.0.351 coma separator ',' replaced by '|'
// since 3.0.0.382
//   - positions 1 and 2 are special! `searcher_name` and `searcher_domain` are replaced by 'user portal name' and by domain of server that Joomla CMS is installed
//   - position 1 is special in additional way: It stores keywords that user use in "Joomla CMS search" feature even if no articles were found to this keywords (and even if user do not open those articles)
//   - position 2 works like all others
//   - searcher_id has been changed
//		$quer[] = 'UPDATE `#__jstats_keywords` SET `searcher_id` = 90 WHERE `searcher_id` = 2';
//		$quer[] = 'UPDATE `#__jstats_keywords` SET `searcher_id` = 91 WHERE `searcher_id` = 3';
//		$quer[] = 'UPDATE `#__jstats_keywords` SET `searcher_id` = 92 WHERE `searcher_id` = 5';
//		$quer[] = 'UPDATE `#__jstats_keywords` SET `searcher_id` = 5  WHERE `searcher_id` = 4';
//		$quer[] = 'UPDATE `#__jstats_keywords` SET `searcher_id` = 3  WHERE `searcher_id` = 1';
//
// !!!Missing value 72!!!
//
$quer[] = "TRUNCATE TABLE `#__jstats_searchers`";

$quer[] = "INSERT IGNORE INTO `#__jstats_searchers` (`searcher_id`, `searcher_name`, `searcher_domain`, `searcher_key`) VALUES
(1, 'Search Joomla CMS', 'your.domain.com', 'searchword='),
(2, 'Joomla CMS', 'your.domain.com', 'searchword='),
(3, 'Google', 'google.', 'p=|q='),
(4, 'Bing','bing.','q='),
(5, 'Altavista', 'altavista.', 'q='),
(6, 'Google Images', 'images.google.', 'p=|q='),
(7, 'Lycos', 'lycos.', 'query='),
(8, 'Msn', 'msn.', 'q='),
(9, 'Netscape', 'netscape.', 'search=|q=|query='),
(10, 'Search AOL', 'search.aol.com', 'query='),
(11, 'Search Terra', 'search.terra.', 'query='),
(12, 'Voila', 'voila.', 'kw=|rdata='),
(13, 'Search.Com', 'www.search.com', 'q='),
(14, 'Yahoo', 'yahoo.', 'p='),
(15, 'Go Com', '.go.com', 'qt='),
(16, 'Ask Com', '.ask.com', 'ask='),
(17, 'Atomz', 'atomz.', 'sp-q='),
(18, 'EuroSeek', 'euroseek.', 'query='),
(19, 'Excite', 'excite.', 'search='),
(20, 'FindArticles', 'findarticles.com', 'key='),
(21, 'Go2Net', 'go2net.com', 'general='),
(22, 'HotBot', 'hotbot.', 'mt='),
(23, 'InfoSpace', 'infospace.com', 'qkw='),
(24, 'Kvasir', 'kvasir.', 'q='),
(25, 'LookSmart', 'looksmart.', 'key='),
(26, 'Mamma', 'mamma.', 'query='),
(27, 'MetaCrawler', 'metacrawler.', 'general='),
(28, 'Nbci.Com', 'nbci.com/search', 'keyword='),
(29, 'Northernlight', 'northernlight.', 'qr='),
(30, 'Overture', 'overture.com', 'keywords='),
(31, 'Dogpile', 'dogpile.com', 'qkw='),
(32, 'Dogpile', 'search.dogpile.com', 'q='),
(33, 'Spray', 'spray.', 'string='),
(34, 'Teoma', 'teoma.', 'q='),
(35, 'Virgilio', 'virgilio.it', 'qs='),
(36, 'Webcrawler', 'webcrawler', 'searchText='),
(37, 'Wisenut', 'wisenut.com', 'query='),
(38, 'ix quick', 'ixquick.com', 'query='),
(39, 'Earthlink', 'search.earthlink.net', 'q='),
(40, 'Sympatico', 'search.sli.sympatico.ca', 'query='),
(41, 'I-une', 'i-une.com', 'keywords=|q='),
(42, 'Miner.Bol.Com', 'miner.bol.com.br', 'q='),
(43, 'Baidu', 'baidu.com', 'word='),
(44, 'Sina', 'search.sina.com', 'word='),
(45, 'Sohu', 'search.sohu.com', 'word='),
(46, 'Atlas cz', 'atlas.cz', 'searchtext='),
(47, 'Seznam cz', 'seznam.cz', 'w='),
(48, 'Ftxt Quick cz', 'ftxt.quick.cz', 'query='),
(49, 'Centrum cz', 'centrum.cz', 'q='),
(50, 'Opasia dk', 'opasia.dk', 'q='),
(51, 'Danielsen', 'danielsen.com', 'q='),
(52, 'Sol dk', 'sol.dk', 'q='),
(53, 'Jubii dk', 'jubii.dk', 'soegeord='),
(54, 'Find dk', 'find.dk', 'words='),
(55, 'Edderkoppen dk', 'edderkoppen.dk', 'query='),
(56, 'Orbis dk', 'orbis.dk', 'search_field='),
(57, '1klik dk', '1klik.dk', 'query='),
(58, 'Ofir dk', 'ofir.dk', 'querytext='),
(59, 'Ilse nl', 'ilse.', 'search_for='),
(60, 'Vindex nl', 'vindex.', 'in='),
(61, 'Ask uk', 'ask.co.uk', 'ask='),
(62, 'BBC uk', 'bbc.co.uk/cgi-bin/search', 'q='),
(63, 'ifind uk', 'ifind.freeserve', 'q='),
(64, 'Looksmart uk', 'looksmart.co.uk', 'key='),
(65, 'mirago uk', 'mirago.', 'txtsearch='),
(66, 'Splut uk', 'splut.', 'pattern='),
(67, 'Spotjockey uk', 'spotjockey.', 'Search_Keyword='),
(68, 'Ukindex uk', 'ukindex.co.uk', 'stext='),
(69, 'Ukdirectory uk', 'ukdirectory.', 'k='),
(70, 'Ukplus uk', 'ukplus.', 'search='),
(71, 'Searchy uk', 'searchy.co.uk', 'search_term='),
(73, 'Haku fi', 'haku.www.fi', 'w='),
(74, 'Nomade fr', 'nomade.fr', 's='),
(75, 'Francite fr', 'francite.', 'name='),
(76, 'Club internet fr', 'recherche.club-internet.fr', 'q='),
(77, 'yandex', 'yandex.ru', 'text='),
(78, 'nigma', 'nigma.ru', 'q='),
(79, 'rambler', 'rambler.ru', 'words='),
(80, 'aport', 'aport.ru', 'r='),
(81, 'mail', 'mail.ru', 'q='),
(82, 'Live Search', 'search.live.com', 'q='),
(83, 'AOL.fr','aol.fr','query=|q='),
(84, 'Conduit.com','conduit.com','q='),
(85, 'live.com','search.live.com','q='),
(86, 'AliceADSL','aliceadsl.fr','qs='),
(87, 'bluewin.ch','bluewin.ch','query='),
(88, 'T-online','t-online.de','q='),
(89, 'ICQ.com','search.icq.com','q=|query='),
(90, 'Alexa', 'alexa.com', 'q='),
(91, 'Alltheweb', 'alltheweb.com', 'query=|q='),
(92, 'DMOZ', 'dmoz.org', 'search=')";

//(90, 'In.gr','find.in.gr','data=')"; //request by user, but it is very rare
//(91, 'Charter.net','charter.net','q=')"; //request by user, but it is very rare






// ###################
//
//  OPERATING SYSTEMS
//
// ###################
//
//define('_JS_DB_OSTYP__ID_UNKNOWN',                   0);
//define('_JS_DB_OSTYP__ID_WINDOWS',                   1);
//define('_JS_DB_OSTYP__ID_LINUX_UNIX_MAC',            2);//linux or unix or mac
//define('_JS_DB_OSTYP__ID_PDA_PHONE',                 3);//pda or phone or mobile
//define('_JS_DB_OSTYP__ID_OTHER',                     4);
//
// NOTICE: 
//   a) no changes from version version 2.2.3 to 2.3.0.158
//   b) index 9 is missing from version v2.1.0 (inclusive)
//
//   c) positions that should be removed: 20, 29, 30
//        32 position is correct?
//        36 position is correct?
//   d) Position 36 catch mainly 'windows nt 4.0' - it is OK, because some NT systems are without version - '(36, 'windows nt', 'Windows NT', 1, 'windows2000')'
//      I made tests on jos_jstats_ipaddresses with 15,375 records - above change made that I losse only 2 real visitors
//   e) #__jstats_systems this table will be renamed to #__jstats_os, all column prefixes also will be renamed to os
//   f) position 33 is correct? 'Windows 2003' - Was it something like this?

$quer[] = "TRUNCATE TABLE #__jstats_systems";

$quer[] = "INSERT IGNORE INTO #__jstats_systems (sys_id, sys_string, sys_fullname, sys_type, sys_img) VALUES
(0, '', 'Unknown', 0, 'unknown'),
(1, 'win95', 'Windows 95', 1, 'windows2000'),
(2, 'windows 95', 'Windows 95', 1, 'windows2000'),
(3, 'win98', 'Windows 98', 1, 'windows2000'),
(4, 'windows 98', 'Windows 98', 1, 'windows2000'),
(5, 'winme', 'Windows me', 1, 'windows2000'),
(6, 'windows me', 'Windows me', 1, 'windows2000'),
(7, 'windows nt 4.0', 'Windows NT', 1, 'windows2000'),
(8, 'windows nt 5.0', 'Windows 2000', 1, 'windows2000'),
(9, 'winnt 5.0', 'Windows 2000', 1, 'windows2000'),
(10, 'winnt 5.1', 'Windows XP', 1, 'windowsxp'),
(11, 'windows nt 5.1', 'Windows XP', 1, 'windowsxp'),
(12, 'macintosh', 'Mac OS', 2, 'mac'),
(13, 'linux', 'Linux', 2, 'linux'),
(14, 'aix', 'Aix', 3, 'aix'),
(15, 'sunos', 'Sun Solaris', 4, 'solaris'),
(16, 'irix', 'Irix', 4, 'irix'),
(17, 'osf', 'OSF Unix', 2, 'linux'),
(18, 'hp-ux', 'HP Unix', 2, 'hpux'),
(19, 'netbsd', 'NetBSD', 2, 'netbsd'),
(20, 'bsdi', 'BSDi', 2, 'freebsd'),
(21, 'freebsd', 'FreeBSD', 2, 'freebsd'),
(22, 'openbsd', 'OpenBSD', 2, 'openbsd'),
(23, 'unix', 'Unknown Unix system', 2, 'unix'),
(24, 'beos', 'BeOS', 4, 'beos'),
(25, 'os/2', 'Warp OS/2', 4, 'os2'),
(26, 'amigaos', 'AmigaOS', 4, 'amiga'),
(27, 'vms', 'VMS', 4, 'vms'),
(28, 'cp/m', 'CPM', 4, 'noimage'),
(29, 'crayos', 'CrayOS', 4, 'cray'),
(30, 'dreamcast', 'Dreamcast', 4, 'dreamcast'), 
(31, 'riscos', 'RISC OS', 4, 'risc'),
(32, 'webtv', 'WebTV', 4, 'webtv'),
(33, 'windows nt 5.2', 'Windows 2003', 1, 'windows2000'),
(34, 'mac_powerpc', 'Mac PowerPC', 2, 'mac'),
(35, 'mac os x', 'Mac OS X', 2, 'mac'),
(36, 'windows nt', 'Windows NT', 1, 'windows2000'),
(37, 'windows nt 6.0', 'Windows Vista', 1, 'windowsvista'),
(38, 'windows nt 6.1', 'Windows 7', 1, 'windows7')";





// TLD
// NOTICE: max index is 273!!!
//in version 2.2.3 only indexes to 269 (inclusive) exists
//
// NOTICE:
//   a) table should be reindexed eg. 6 should be reserved for 'ah'
//   b) we should add below values:
//         - 'localhost'
//         - 'intranet'

$quer[] = "TRUNCATE TABLE #__jstats_topleveldomains";


$quer[] = "INSERT IGNORE INTO #__jstats_topleveldomains (tld_id, tld, fullname) VALUES
(0, 'unknown', 'Unknown'),
(1, 'ac', 'Ascension Island'),
(2, 'ad', 'Andorra'),
(3, 'ae', 'United Arab Emirates'),
(4, 'af', 'Afghanistan'),
(5, 'ag', 'Antigua and Barbuda'),
(6, 'ai', 'Anguilla'),
(7, 'al', 'Albania'),
(8, 'am', 'Armenia'),
(9, 'an', 'Netherlands Antilles'),
(10, 'ao', 'Angola'),
(11, 'aq', 'Antarctica'),
(12, 'ar', 'Argentina'),
(13, 'as', 'American Samoa'),
(14, 'at', 'Austria'),
(15, 'au', 'Australia'),
(16, 'aw', 'Aruba'),
(17, 'ax', 'Aland Islands'),
(18, 'az', 'Azerbaijan'),
(19, 'ba', 'Bosnia Hercegovina'),
(20, 'bb', 'Barbados'),
(21, 'bd', 'Bangladesh'),
(22, 'be', 'Belgium'),
(23, 'bf', 'Burkina Faso'),
(24, 'bg', 'Bulgaria'),
(25, 'bh', 'Bahrain'),
(26, 'bi', 'Burundi'),
(27, 'bj', 'Benin'),
(28, 'bm', 'Bermuda'),
(29, 'bn', 'Brunei Darussalam'),
(30, 'bo', 'Bolivia'),
(31, 'br', 'Brazil'),
(32, 'bs', 'Bahamas'),
(33, 'bt', 'Bhutan'),
(34, 'bv', 'Bouvet Island'),
(35, 'bw', 'Botswana'),
(36, 'by', 'Belarus (Byelorussia)'),
(37, 'bz', 'Belize'),
(38, 'ca', 'Canada'),
(39, 'cc', 'Cocos Islands (Keeling)'),
(40, 'cd', 'Congo, Democratic Republic of the'),
(41, 'cf', 'Central African Republic'),
(42, 'cg', 'Congo, Republic of'),
(43, 'ch', 'Switzerland'),
(44, 'ci', 'Cote d\'Ivoire (Ivory Coast)'),
(45, 'ck', 'Cook Islands'),
(46, 'cl', 'Chile'),
(47, 'cm', 'Cameroon'),
(48, 'cn', 'China'),
(49, 'co', 'Colombia'),
(50, 'cr', 'Costa Rica'),
(51, 'cs', 'Serbia and Montenegro'),
(52, 'cu', 'Cuba'),
(53, 'cv', 'Cap Verde'),
(54, 'cx', 'Christmas Island'),
(55, 'cy', 'Cyprus'),
(56, 'cz', 'Czech Republic'),
(57, 'de', 'Germany'),
(58, 'dj', 'Djibouti'),
(59, 'dk', 'Denmark'),
(60, 'dm', 'Dominica'),
(61, 'do', 'Dominican Republic'),
(62, 'dz', 'Algeria'),
(63, 'ec', 'Ecuador'),
(64, 'ee', 'Estonia'),
(65, 'eg', 'Egypt'),
(66, 'eh', 'Western Sahara'),
(67, 'er', 'Eritrea'),
(68, 'es', 'Spain'),
(69, 'et', 'Ethiopia'),
(70, 'fi', 'Finland'),
(71, 'fj', 'Fiji'),
(72, 'fk', 'Falkland Islands'),
(73, 'fm', 'Micronesia, Federated States of'),
(74, 'fo', 'Faroe Islands'),
(75, 'fr', 'France'),
(76, 'ga', 'Gabon'),
(77, 'gb', 'United Kingdom'),
(78, 'gd', 'Grenada'),
(79, 'ge', 'Georgia'),
(80, 'gf', 'French Guiana'),
(81, 'gg', 'Guernsey'),
(82, 'gh', 'Ghana'),
(83, 'gi', 'Gibraltar'),
(84, 'gl', 'Greenland'),
(85, 'gm', 'Gambia'),
(86, 'gn', 'Guinea'),
(87, 'gp', 'Guadeloupe'),
(88, 'gq', 'Equatorial Guinea'),
(89, 'gr', 'Greece'),
(90, 'gs', 'South Georgia and the South Sandwich Islands'),
(91, 'gt', 'Guatemala'),
(92, 'gu', 'Guam'),
(93, 'gw', 'Guinea-Bissau'),
(94, 'gy', 'Guyana'),
(95, 'hk', 'Hong Kong'),
(96, 'hm', 'Heard and McDonald Islands'),
(97, 'hn', 'Honduras'),
(98, 'hr', 'Croatia/Hrvatska'),
(99, 'ht', 'Haiti'),
(100, 'hu', 'Hungary'),
(101, 'id', 'Indonesia'),
(102, 'ie', 'Ireland'),
(103, 'il', 'Israel'),
(104, 'im', 'Isle of Man'),
(105, 'in', 'India'),
(106, 'io', 'British Indian Ocean Territory'),
(107, 'iq', 'Iraq'),
(108, 'ir', 'Iran, Islamic Republic of'),
(109, 'is', 'Iceland'),
(110, 'it', 'Italy'),
(111, 'je', 'Jersey'),
(112, 'jm', 'Jamaica'),
(113, 'jo', 'Jordan'),
(114, 'jp', 'Japan'),
(115, 'ke', 'Kenya'),
(116, 'kg', 'Kyrgyzstan'),
(117, 'kh', 'Cambodia'),
(118, 'ki', 'Kiribati'),
(119, 'km', 'Comoros'),
(120, 'kn', 'Saint Kitts and Nevis'),
(121, 'kp', 'Korea, Democratic People\'s Republic'),
(122, 'kr', 'Korea, Republic of'),
(123, 'kw', 'Kuwait'),
(124, 'ky', 'Cayman Islands'),
(125, 'kz', 'Kazakhstan'),
(126, 'la', 'Lao People\'s Democratic Republic'),
(127, 'lb', 'Lebanon'),
(128, 'lc', 'Saint Lucia'),
(129, 'li', 'Liechtenstein'),
(130, 'lk', 'Sri Lanka'),
(131, 'lr', 'Liberia'),
(132, 'ls', 'Lesotho'),
(133, 'lt', 'Lithuania'),
(134, 'lu', 'Luxembourg'),
(135, 'lv', 'Latvia'),
(136, 'ly', 'Libyan Arab Jamahiriya'),
(137, 'ma', 'Morocco'),
(138, 'mc', 'Monaco'),
(139, 'md', 'Moldova, Republic of'),
(271, 'me', 'Montenegro'),
(140, 'mg', 'Madagascar'),
(141, 'mh', 'Marshall Islands'),
(142, 'mk', 'Macedonia, Former Yugoslav Republic'),
(143, 'ml', 'Mali'),
(144, 'mm', 'Myanmar'),
(145, 'mn', 'Mongolia'),
(146, 'mo', 'Macau'),
(147, 'mp', 'Northern Mariana Islands'),
(148, 'mq', 'Martinique'),
(149, 'mr', 'Mauritani'),
(150, 'ms', 'Montserrat'),
(151, 'mt', 'Malta'),
(152, 'mu', 'Mauritius'),
(153, 'mv', 'Maldives'),
(154, 'mw', 'Malawi'),
(155, 'mx', 'Mexico'),
(156, 'my', 'Malaysia'),
(157, 'mz', 'Mozambique'),
(158, 'na', 'Namibia'),
(159, 'nc', 'New Caledonia'),
(160, 'ne', 'Niger'),
(161, 'nf', 'Norfolk Island'),
(162, 'ng', 'Nigeria'),
(163, 'ni', 'Nicaragua'),
(164, 'nl', 'Netherlands'),
(165, 'no', 'Norway'),
(166, 'np', 'Nepal'),
(167, 'nr', 'Nauru'),
(168, 'nt', 'Neutral Zone'),
(169, 'nu', 'Niue'),
(170, 'nz', 'New Zealand'),
(171, 'om', 'Oman'),
(172, 'pa', 'Panama'),
(173, 'pe', 'Peru'),
(174, 'pf', 'French Polynesia'),
(175, 'pg', 'Papua New Guinea'),
(176, 'ph', 'Philippines'),
(177, 'pk', 'Pakistan'),
(178, 'pl', 'Poland'),
(179, 'pm', 'St. Pierre and Miquelon'),
(180, 'pn', 'Pitcairn Island'),
(181, 'pr', 'Puerto Rico'),
(182, 'ps', 'Palestinian Territories'),
(183, 'pt', 'Portugal'),
(184, 'pw', 'Palau'),
(185, 'py', 'Paraguay'),
(186, 'qa', 'Qatar'),
(187, 're', 'Reunion Island'),
(188, 'ro', 'Romania'),
(272, 'rs', 'Serbia'),
(189, 'ru', 'Russian Federation'),
(190, 'rw', 'Rwanda'),
(191, 'sa', 'Saudi Arabia'),
(192, 'sb', 'Solomon Islands'),
(193, 'sc', 'Seychelles'),
(194, 'sd', 'Sudan'),
(195, 'se', 'Sweden'),
(196, 'sg', 'Singapore'),
(197, 'sh', 'St. Helena'),
(198, 'si', 'Slovenia'),
(199, 'sj', 'Svalbard and Jan Mayen Islands'),
(200, 'sk', 'Slovak Republic'),
(201, 'sl', 'Sierra Leone'),
(202, 'sm', 'San Marino'),
(203, 'sn', 'Senegal'),
(204, 'so', 'Somalia'),
(205, 'sr', 'Suriname'),
(206, 'st', 'Sao Tome and Principe'),
(207, 'su', 'Former Soviet Union'),
(208, 'sv', 'El Salvador'),
(209, 'sy', 'Syrian Arab Republic'),
(210, 'sz', 'Swaziland'),
(211, 'tc', 'Turks and Caicos Islands'),
(212, 'td', 'Chad'),
(213, 'tf', 'French Southern Territories'),
(214, 'tg', 'Togo'),
(215, 'th', 'Thailand'),
(216, 'tj', 'Tajikistan'),
(217, 'tk', 'Tokelau'),
(218, 'tl', 'East Timor'),
(219, 'tm', 'Turkmenistan'),
(220, 'tn', 'Tunisia'),
(221, 'to', 'Tonga'),
(222, 'tp', 'East Timor'),
(223, 'tr', 'Turkey'),
(224, 'tt', 'Trinidad and Tobago'),
(225, 'tv', 'Tuvalu'),
(226, 'tw', 'Taiwan'),
(227, 'tz', 'Tanzania'),
(228, 'ua', 'Ukraine'),
(229, 'ug', 'Uganda'),
(230, 'uk', 'United Kingdom'),
(231, 'um', 'US Minor Outlying Islands'),
(232, 'us', 'United States'),
(233, 'uy', 'Uruguay'),
(234, 'uz', 'Uzbekistan'),
(235, 'va', 'Holy See (City Vatican State)'),
(236, 'vc', 'Saint Vincent and the Grenadines'),
(237, 've', 'Venezuela'),
(238, 'vg', 'Virgin Islands (British)'),
(239, 'vi', 'Virgin Islands (USA)'),
(240, 'vn', 'Vietnam'),
(241, 'vu', 'Vanuatu'),
(242, 'wf', 'Wallis and Futuna Islands'),
(243, 'ws', 'Western Samoa'),
(244, 'ye', 'Yemen'),
(245, 'yt', 'Mayotte'),
(246, 'yu', 'Serbia and Montenegro'),
(247, 'za', 'South Africa'),
(248, 'zm', 'Zambia'),
(249, 'zw', 'Zimbabwe'),

(250, 'eu', 'European Union'),
(251, 'cat', 'Catalonia'),
(273, 'asia', 'Asia'),

(252, 'com', 'Commercial'),
(253, 'net', 'Network'),
(254, 'org', 'Organization'),

(255, 'gov', 'US Government'),
(256, 'mil', 'US Military (Dept of Defense)'),

(257, 'int', 'International Organizations'),

(258, 'aero', 'Aviation Industry'),
(259, 'biz', 'Businesses'),
(260, 'coop', 'Cooperatives'),
(261, 'edu', 'Educational Institutions'),
(262, 'info', 'Worldwide unrestricted use'),
(263, 'jobs', 'Job Offering Companies'),
(264, 'mobi', 'Mobile Internet Services'),
(265, 'museum', 'Museums'),
(266, 'name', 'Individuals and Families'),
(267, 'pro', 'Attorneys, Physicians, Engineers, and Accountants'),
(274, 'tel', 'Telephone Service'),
(268, 'travel', 'Travel and Tourism Industry'),
(269, 'arpa', 'Old Style Arpanet')";
